Require Import connectives.
Require Import leibniz.
Require Import logic.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Definition sym_eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (return_ (S n)) (filter_nat_type (return_type) return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
Axiom nat_ind : forall (Q:(nat -> Prop)), (Q O) -> (forall (x:nat), (Q x) -> Q (S x)) -> forall (x:nat), Q x.
Parameter plus : nat -> nat -> nat.
Parameter plus_body : nat -> nat -> nat.
Axiom axiom_plus : forall (n:nat), connectives.equal (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n).
Definition eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((axiom_plus) (n)).
Definition sym_eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) plus_body n) (plus n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((eq_plus) (n)).
Axiom axiom_plus_body_O : connectives.equal (nat -> nat) (plus_body O) (fun (m:nat) => m).
Definition eq_plus_body_O : leibniz.leibniz (nat -> nat) (plus_body O) (fun (m:nat) => m) := ((((connectives.equal_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (axiom_plus_body_O).
Definition sym_eq_plus_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => m) (plus_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (eq_plus_body_O).
Parameter times : nat -> nat -> nat.
Parameter times_body : nat -> nat -> nat.
Axiom axiom_times : forall (n:nat), connectives.equal (nat -> nat) (times n) (filter_nat_type (nat -> nat) times_body n).
Definition eq_times : forall (n:nat), leibniz.leibniz (nat -> nat) (times n) (filter_nat_type (nat -> nat) times_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (times n)) (filter_nat_type (nat -> nat) times_body n)) ((axiom_times) (n)).
Definition sym_eq_times : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) times_body n) (times n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (times n)) (filter_nat_type (nat -> nat) times_body n)) ((eq_times) (n)).
Axiom axiom_times_body_O : connectives.equal (nat -> nat) (times_body O) (fun (m:nat) => O).
Definition eq_times_body_O : leibniz.leibniz (nat -> nat) (times_body O) (fun (m:nat) => O) := ((((connectives.equal_leibniz) (nat -> nat)) (times_body O)) (fun (m:nat) => O)) (axiom_times_body_O).
Definition sym_eq_times_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => O) (times_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (times_body O)) (fun (m:nat) => O)) (eq_times_body_O).
Axiom axiom_times_body_S : forall (n:nat), connectives.equal (nat -> nat) (times_body (S n)) (fun (m:nat) => plus m (times n m)).
Definition eq_times_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (times_body (S n)) (fun (m:nat) => plus m (times n m)) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (times_body (S n))) (fun (m:nat) => plus m (times n m))) ((axiom_times_body_S) (n)).
Definition sym_eq_times_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => plus m (times n m)) (times_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (times_body (S n))) (fun (m:nat) => plus m (times n m))) ((eq_times_body_S) (n)).
Definition plus_O_n : forall (n:nat), logic.eq (nat) n (plus O n) := fun (n:nat) => (((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) n (y n))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) n (y n))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) n (y n))) (((logic.refl) (nat)) (n)))).
Definition times_Sn_m : forall (n:nat), forall (m:nat), logic.eq (nat) (plus m (times n m)) (times (S n) m) := fun (n:nat) => fun (m:nat) => (((sym_eq_times) (S n)) (fun (y:(nat -> nat)) => logic.eq (nat) (plus m (times n m)) (y m))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (times_body)) (n)) (fun (y:(nat -> nat)) => logic.eq (nat) (plus m (times n m)) (y m))) ((((sym_eq_times_body_S) (n)) (fun (y:(nat -> nat)) => logic.eq (nat) (plus m (times n m)) (y m))) (((logic.refl) (nat)) (plus m (times n m))))).
Definition times_O_n : forall (n:nat), logic.eq (nat) O (times O n) := fun (n:nat) => (((sym_eq_times) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y n))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (times_body)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y n))) (((sym_eq_times_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) O (y n))) (((logic.refl) (nat)) (O)))).
Definition times_n_O : forall (n:nat), logic.eq (nat) O (times n O) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => logic.eq (nat) O (times _x_365 O))) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (nat) O __)) (((logic.refl) (nat)) (O))) (times O O)) ((times_O_n) (O)))) (fun (x_366:nat) => fun (_x_368:logic.eq (nat) O (times x_366 O)) => (((((((logic.rewrite_l) (nat)) (plus O (times x_366 O))) (fun (__:nat) => logic.eq (nat) O __)) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (nat) O (plus O __))) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (nat) O __)) (((logic.refl) (nat)) (O))) (plus O O)) ((plus_O_n) (O)))) (times x_366 O)) (_x_368))) (times (S x_366) O)) (((times_Sn_m) (x_366)) (O))))) (n).
